/*

  Dodatkowe funkcje dla skryptw LUA z dodatkowym kolektorem mieci do usuwania
  np. nieuywanych timerw i uchwytw sieciowych...

  Aby z niego korzysta, trzeba utworzy obiekt cLuaEx przekazujc do niego
  zainicjalizowany ju LuaState * razem z opcjonalnym parametrem i flagami.
  Podczas tworzenia obiektu, w LuaState zostan zarejestrowane funkcje wskazane
  przez flagi. Dodatkowo zostanie zarejestrowana globalna tablica - LuaPlusEx
  w ktrej dostpne bd podstawowe wskaniki i by moe jakie funkcje...

  W obiekcie LuaState i m_state nie s przechowywane adne dodatkowe informacje...
  Do wycigania wskanika do cLuaEx moe suy odpowiednia funkcja...

  Aby umoliwi f-cjom LuaEx logowanie, trzeba ustawi logujcy CallBack.
  Podobnie, jeli chcesz wczy przygotowywanie informacji o zapanych bdach...
  Na razie informacje te s w stosunku do LuaState mocno nie pene, ale jeszcze
  nie rozgryzem czemu tak akurat si dzieje...

  Zmiany w kodzie LuaPlus:
    -> nowy typ - LuaStateOutString do dumpowania obiektow do tekstu
    -> nowa funkcjonalno w f-cji wywoywanej z LUA - LuaDumpObject:
       jeeli pierwszym parametrem jest nil, zrzut zostanie zwrcony z funkcji...

*/

#ifndef ____LUAEX_H
#define ____LUAEX_H

#define LUA_OPENLIB_GLOBAL
#include <luaPlus.h>

#ifndef LUAEX_PARAM_TYPE
    #define LUAEX_PARAM_TYPE void
#endif

#define LuaExP(ex) ((LUAEX_PARAM_TYPE *)ex->param)

#define LEI_DEFAULT  0xFF

#define LEI_GC     1 // Kolektory
#define LEI_BASE   2 // Podstawowe rzeczy jak cp2iso, urlEncode, time itp...
#define LEI_DLGBOX 4 // 
#define LEI_REGEXP 0x8 // 
#define LEI_INET   0x10 // 

#define LEI_SPECIAL 0xFF00
#define LEI_GCUSER 0x100 // GarbageCollector w GC
//#define LEI_TOKEN  0x200 // 


using namespace LuaPlus;

struct cLUAErrorInfo {
    lua_Debug debug;
    const char * txtInfo;
};

class LUA_API cLuaEx {
public:
    typedef void (*errorCallback)(cLuaEx * Ex , const cLUAErrorInfo * nfo);
    typedef void (*logCallback)(cLuaEx * Ex , const char * txt);

    inline cLuaEx(LuaState * state , int flags = LEI_DEFAULT , void * param = 0):state(state),param(param) {init(flags);}
    ~cLuaEx();

    void setErrorCallBack(errorCallback cb);
    void setLogCallBack(logCallback cb);


    LuaState * state;
    void * param;
    class cGarbageCollection * GC;

private:
    void init(int flags);

    // cLUA uzywa tych kolektorow
    class cGarbageCollection * GC_inet;
//    class cGarbageCollection * GC_timer;

    errorCallback _cbError;
    logCallback _cbLog;

public:
    // F-cje dla skryptw...

    int LS_ERROR(LuaState* state, LuaStackObject* args);
    static int LS_ERRORDISPATCH(lua_State* state);

    int LS_LOG(LuaState* state, LuaStackObject* args);

    static int LS_preg_match(LuaState* state, LuaStackObject* args);
    static int LS_preg_matchAll(LuaState* state, LuaStackObject* args);
    static int LS_preg_matchReturn(LuaState* state, LuaStackObject* args);
    static int LS_preg_replace(LuaState* state, LuaStackObject* args);
    static int LS_iso2cp(LuaState* state, LuaStackObject* args);
    static int LS_cp2iso(LuaState* state, LuaStackObject* args);
    static int LS_hidePL(LuaState* state, LuaStackObject* args);
    static int LS_urlEncode(LuaState* state, LuaStackObject* args);
    static int LS_urlDecode(LuaState* state, LuaStackObject* args);
            int LS_InternetOpen(LuaState* state, LuaStackObject* args);
            int LS_InternetConnect(LuaState* state, LuaStackObject* args);
            int LS_HttpOpenRequest(LuaState* state, LuaStackObject* args);
    static int LS_HttpSendRequest(LuaState* state, LuaStackObject* args);
    static int LS_InternetReadFile(LuaState* state, LuaStackObject* args);
    static int LS_InternetWriteFile(LuaState* state, LuaStackObject* args);
            int LS_InternetCloseHandle(LuaState* state, LuaStackObject* args);
    static int LS_InternetGetCookie(LuaState* state, LuaStackObject* args);
    static int LS_InternetSetCookie(LuaState* state, LuaStackObject* args);
    static int LS_InternetGetLastResponseInfo(LuaState* state, LuaStackObject* args);
    static int LS_HttpQueryInfo(LuaState* state, LuaStackObject* args);
    static int LS_InternetQueryOption(LuaState* state, LuaStackObject* args);
    static int LS_InternetSetOption(LuaState* state, LuaStackObject* args);
		   int LS_InternetErrorDlg(LuaState* state, LuaStackObject* args);
    static int LS_time(LuaState* state, LuaStackObject* args);
    static int LS_include(LuaState* state, LuaStackObject* args);
	static int LS_GetLastError(LuaState* state, LuaStackObject* args);
    static int LS_GetErrorMessage(LuaState* state, LuaStackObject* args);

//    static int LS_alert(LuaState* state, LuaStackObject* args);
//    static int LS_confirm(LuaState* state, LuaStackObject* args);


// dodatkowo:


};




// --------------------------------------------------------------------------------------



#endif